import java.lang.*;
import java.net.*;
import java.util.*;
import java.io.*;

class UDPconn 
{
  
   DatagramSocket dsock;
   DatagramPacket packet;
   InetAddress Taddress;
   int Port;

   public void open_read(int port)
   {     
     try {
	   dsock = new DatagramSocket(port);
	 } 
     catch(Exception e) {
           System.out.println("Err: " + e);
	   System.exit(1);
         }
   }
  
   public void read(byte inbuffer[],int LENGHT) 
   {
     byte BUFFER[] = new byte[LENGHT];
 
     packet = new DatagramPacket(BUFFER, LENGHT);

     try {
	     dsock.receive(packet);
	 } 
     catch(Exception e) {
             System.out.println("Err: " + e);
	     System.exit(1);
         }
	  
     for(int i = 0; i < LENGHT; i ++) 
        inbuffer[i]=packet.getData()[i];
   }


   public void open_write(String host, int _port)
   {

     Port=_port;
     try {
	   Taddress = InetAddress.getByName(host);
	 } 
     catch(Exception e) {
           System.out.println("Err: " + e);
	   Taddress = null;
	   System.exit(1);
         }
     
     try {
	   dsock = new DatagramSocket();
     	 } 
     catch(Exception e) {
           System.out.println("Err: " + e);
	   System.exit(1);
         }
   }	

   public void write(byte outbuffer[], int LENGHT) 
   {
     byte BUFFER[] = new byte[LENGHT];
 
     for (int i = 0; i < LENGHT; i ++) 
         {
           BUFFER[i] = outbuffer[i];
	 }

     packet = new DatagramPacket(BUFFER, LENGHT, Taddress, Port);

     try {
	     dsock.send(packet);
	 } 
     catch(Exception e) {
	     System.out.println("Err: " + e);
	     System.exit(1);
         }	  
     
   }

   public void close_socket()
   {
     try {
	     dsock.close();
	     System.out.println("socket closed");
	 } 
     catch(Exception e) {
	     System.out.println("Err: " + e);
	     System.exit(1);
         }	  
   }  
}

























